﻿-- KBM: Add Watch 
-- Written by Paul Snart
-- Copyright 2012

KBMPIAW_Settings = nil
chKBMPIAW_Settings = nil

-- New Internal Level Icons
-- "emblem_boss.png.dds" -- Elite
-- "emblem_deathcon.png.dds" -- ?? Level
-- "emblem_elite.png.dds" -- Raid Boss
-- "emblem_normal.png.dds" -- Normal

local AddonIni = ...

local AddonData = Inspect.Addon.Detail("KingMolinator")
local Run = true

local LSUIni = Inspect.Addon.Detail("SafesUnitLib")
local LibSUnit 
if LSUIni then
	LibSUnit = LSUIni.data
else
	Run = false
end

local LSCIni = Inspect.Addon.Detail("SafesCastbarLib")
local LibSCast
if LSCIni then
	LibSCast = LSCIni.data
else
	Run = false
end

local MARK_LAYER = 8

local PI = {
	Context = UI.CreateContext("KBM_AddWatch"),
	ID = AddonIni.id,
	Name = "Add-Watch",
	APIData = AddonIni,
	Menu = {},
	Lang = {},
	TempGUI = {},
	TempUGUI = {},
	Marks = {
		Icon = {},
		Frame = {},
	},
	Cached = 0,
	MaxCache = 20,
	Frame = {},
	Stores = {
		Frames = {},
		Units = {},
	},
	Constant = {
		Frame = {
			Width = 250,
			Height = 26,
			TextSize = 12,
		},
	},
	MinVersion = {
		High = 1,
		Mid = 5,
		Low = 5,
		Revision = 758,
	},
	Unit = {},
	LastTime = 0,
	TRUCurrent = nil,
}
PI.Context:SetLayer(2)
local AWCastCount = 0

local Lang = Inspect.System.Language()
local KBM = nil

if not Run then
	print("**************")
	if Lang == "French" then
		print("King Boss Mods pas installé, veuillez installé la dernière version."..
				"\nKBM-AW01: écher lien Plug-In.")
	elseif Lang == "German" then
		print("Veraltete Version von King Boss Mods gefunden. Bitte installiert die letzte Version."..
				"\nKBM-AW01: Plug-In Link fehlerhaft.")
	else
		print("King Boss Mods not installed, please install the latest version."..
				"\nKBM-AW01: Plug-In link failed.")	
	end
	print("**************")
	Run = false
else
	KBM = AddonData.data
	if not KBM then
		print("**************")
		if Lang == "French" then
			print("Version incorrecte de King Boss Mods installée. SVP installé la dernière version."..
					"\nKBM-AW02: écher lien Plug-In.")
		elseif Lang == "German" then
			print("Veraltete Version von King Boss Mods gefunden. Bitte installiert die letzte Version."..
					"\nKBM-AW02: Plug-In Link fehlerhaft.")
		else
			print("Incorrect version of King Boss Mods installed. Please install the latest version."..
					"\nKBM-AW02: Plug-In link failed.")
		end
		print("**************")
		Run = false
	end

	if Run then
		-- Addon Dictionary
		-- Frame Related
		PI.Lang.Frames = {}
		PI.Lang.Frames.Smart = KBM.Language:Add("Enable Smart-Tracking during encounters")
		PI.Lang.Frames.Smart:SetGerman("Aktiviere Smart-Tracking während Boss-Gegnern")
		PI.Lang.Frames.Smart:SetFrench("Activer Tracking intelligent durant les combats")
		PI.Lang.Frames.Mark = KBM.Language:Add("Display raid marks")
		PI.Lang.Frames.Mark:SetGerman("Zeige Markierungs-Nummern an")
		PI.Lang.Frames.Mark:SetFrench("Afficher numéro marquage")
		PI.Lang.Frames.Target = KBM.Language:Add("Display total group members targeting")
		PI.Lang.Frames.Target:SetGerman("Zeige Anzahl der Spieler, welche markiertes Ziel anvisieren")
		PI.Lang.Frames.Target:SetFrench("Afficher total joueur(s) du groupe qui ont ciblé")
		PI.Lang.Frames.Display = KBM.Language:Add("Show tracked units to the Right")
		PI.Lang.Frames.Display:SetGerman("Zeige an, welche Spieler ein markiertes Ziel anvisieren")
		PI.Lang.Frames.Display:SetFrench("Afficher unités traquées à la Droite")
		PI.Lang.Frames.Level = KBM.Language:Add("Display unit level")
		PI.Lang.Frames.Level:SetGerman("Zeige Mob-Level an")
		PI.Lang.Frames.Level:SetFrench("Afficher niveau des unités")
		PI.Lang.Frames.Power = KBM.Language:Add("Display unit power/mana/energy levels")
		PI.Lang.Frames.Power:SetGerman("Zeige Kraft-/Mana-/Energie-Wert vom Mob an")
		PI.Lang.Frames.Power:SetFrench("Afficher niveau puissance/mana/énergie des unités")
		PI.Lang.Frames.Cascade = KBM.Language:Add("Unit frames Cascade below first frame")
		PI.Lang.Frames.Cascade:SetGerman("Angezeigte Einheiten werden nach unten sortiert") 
		PI.Lang.Frames.Cascade:SetFrench("Cadre Unités en cascade sous premier cadre")
		PI.Lang.Frames.TargetTop = KBM.Language:Add("Place my target first in the list")
		PI.Lang.Frames.TargetTop:SetFrench("Mettre ma cible en premier dans la liste")
		PI.Lang.Frames.Unknown = KBM.Language:Add("Track <Unknown> Units")

		-- Pin Related
		PI.Lang.Pin = {}
		PI.Lang.Pin.Anchor = KBM.Language:Add("AddWatch Unit Anchor")
		PI.Lang.Pin.Visible = KBM.Language:Add("Unlock Pin Anchor (for positioning)")
		PI.Lang.Pin.Visible:SetGerman("Haupt-Anker ist verschiebbar.")
		PI.Lang.Pin.Visible:SetFrench("Débloquer ancrage (pour positionnement)")

		-- Error Related
		PI.Lang.Error = {}
		PI.Lang.Error.Install = KBM.Language:Add("Incorrect version of King Boss Mods installed. Please install the latest version.")
		PI.Lang.Error.Install:SetGerman("Veraltete Version von King Boss Mods gefunden. Bitte installiert die letzte Version.")
		PI.Lang.Error.Install:SetFrench("Version incorrecte de King Boss Mods installée. SVP installé la dernière version.")
		PI.Lang.Error.PlugIn = KBM.Language:Add(": Plug-In link failed.")
		PI.Lang.Error.PlugIn:SetFrench(": écher lien Plug-In.")
		PI.Lang.Error.PlugIn:SetGerman("Plug-In Link fehlerhaft")

		if not KBM.Version:Check(PI.MinVersion.High, PI.MinVersion.Mid, PI.MinVersion.Low, PI.MinVersion.Revision) then
			print("**************")
			print(PI.Name.." is expecting at least KBM v"..PI.MinVersion.High.."."..PI.MinVersion.Mid.."."..PI.MinVersion.Low.."."..PI.MinVersion.Revision..
					"\n"..PI.Lang.Error.Install[KBM.Lang].."\nKBM-AWV01: Version Incompatible")
			print("**************")
			Run = false
		elseif KBM.Alpha then
			if type(KBM.Alpha) == "string" then
				local s, e, l_Alpha = string.find(KBM.Alpha, "[.r](%d+)")
				l_Alpha = tonumber(l_Alpha)
				if l_Alpha < PI.MinVersion.Revision then
					print("**************")
					print(PI.Name.." is expecting at least KBM r"..PI.MinVersion.Alpha.." alpha"..
							"\n"..PI.Lang.Error.Install[KBM.Lang].."\nKBM-AWV01: Version Incompatible")
					print("**************")
					Run = false
				end
			end
		end

		if Run then
			if KBM.PlugIn.Register then
				KBM.PlugIn.Register(PI)
			else
				print("**************")
				print(PI.Lang.Error.Install[KBM.Lang].."\nKBM-AW03"..PI.Lang.Error.PlugIn[KBM.Lang])
				print("**************")
				Run = false
			end
		end
	end
end

PI.Defaults = {}
function PI.Defaults.Unit()
	local UnitObj = {
		Type = "Unit",
	}
	return UnitObj
end

PI.Version = {}
function PI.Version:Load()
	local s = 0
	local e = 0
	s, e, self.High, self.Mid, self.Low, self.Revision = string.find(AddonIni.toc.Version, "(%d+).(%d+).(%d+).(%d+)")
	if self.High then
		self.High = tonumber(self.High)
	else
		self.High = 0
	end
	if self.Mid then
		self.Mid = tonumber(self.Mid)
	else
		self.Mid = 0
	end
	if self.Low then
		self.Low = tonumber(self.Low)
	else
		self.Low = 0
	end
	if self.Revision then
		self.Revision = tonumber(self.Revision)
	else
		self.Revision = 0
	end
end
PI.Version:Load()

function PI.Version:Check(Rev)
	if self.Revision < Rev then
		return false
	else
		return true
	end
end


function PI:InitVars()
	self.Settings = {
		Enabled = true,
		Anchor = {
			wScale = 1,
			hScale = 1,
			tScale = 1,
			ScaleText = false,
			ScaleHeight = false,
			ScaleWidth = false,
			Visible = false,
			x = false,
			y = false,
		},
		Unknown = false,
		SmartTrack = true,
		Marks = true,
		Targets = true,
		ShowRight = true,
		ShowLevel = true,
		ShowPower = true,
		Cascade = true,
		TargetTop = true,
	}	
	KBMPIAW_Settings = self.Settings
	chKBMPIAW_Settings = self.Settings	
end

function PI:SwapSettings(bool)
	if bool then
		KBMPIAW_Settings = self.Settings
		self.Settings = chKBMPIAW_Settings
	else
		chKBMPIAW_Settings = self.Settings
		self.Settings = KBMPIAW_Settings
	end
end

function PI:LoadVars()		
	if KBM.Options.Character then
		KBM.LoadTable(chKBMPIAW_Settings, self.Settings)
	else
		KBM.LoadTable(KBMPIAW_Settings, self.Settings)
	end
		
	if KBM.Options.Character then
		chKBMPIAW_Settings = self.Settings
	else
		KBMPIAW_Settings = self.Settings
	end
end

function PI:SaveVars()	
	if KBM.Options.Character then
		chKBMPIAW_Settings = self.Settings
	else
		KBMPIAW_Settings = self.Settings
	end	
end

if Run then
	local AddWatch_CastSettings = LibSCast.Default.BarSettings()
	AddWatch_CastSettings.pack = "Simple"
	AddWatch_CastSettings.texture.foreground.enabled = false
	AddWatch_CastSettings.unlocked = false
	AddWatch_CastSettings.visible = false
end

function PI:PullUnit()
	local GUI = nil
	if #self.Stores.Units > 0 then
		GUI = table.remove(self.Stores.Units)
	else
		GUI = {}
		GUI.Cradle = UI.CreateFrame("Frame", "KBMAW_Target_Units_Cradle", KBM.Context)
		GUI.Cradle:SetBackgroundColor(0,0,0,0)
		GUI.Cradle:SetHeight(self.GUI.Anchor:GetHeight() - 4)
		GUI.Cradle:SetWidth(self.GUI.Anchor:GetWidth() - 4)
		GUI.Cradle:SetLayer(7)
		GUI.Shadow = UI.CreateFrame("Text", "KBMAW_Target_Units_Shadow", GUI.Cradle)
		GUI.Shadow:SetFontColor(0,0,0)
		GUI.Shadow:SetPoint("CENTERY", GUI.Cradle, "CENTERY", nil, 1)
		GUI.Shadow:SetPoint("LEFT", GUI.Cradle, "LEFT", 2, nil)
		GUI.Shadow:SetLayer(1)
		GUI.Shadow:SetAlpha(1)
		GUI.Text = UI.CreateFrame("Text", "KBMAW_Target_Units_Text", GUI.Shadow)
		GUI.Text:SetFontColor(1,1,1)
		GUI.Text:SetPoint("TOPLEFT", GUI.Shadow, "TOPLEFT", 0, -1)
		GUI.Text:SetLayer(2)
		GUI.Text:SetAlpha(1)
		
		function GUI:SetText(Text, Class)
			if Class == "mage" then
				self.Text:SetFontColor(0.8, 0.55, 1, 1)
			elseif Class == "cleric" then
				self.Text:SetFontColor(0.55, 1, 0.55, 1)
			elseif Class == "warrior" then
				self.Text:SetFontColor(1, 0.55, 0.55, 1)
			elseif Class == "rogue" then
				self.Text:SetFontColor(1, 1, 0.55, 1)
			else
				self.Text:SetFontColor(1,1,1,1)
			end
			self.Shadow:SetText(Text)
			self.Text:SetText(Text)
		end
	end
	return GUI
end

function PI:PullFrame(UnitObj)
	local GUI = nil
	if #self.Stores.Frames > 0 then
		GUI = table.remove(self.Stores.Frames)
	else
		GUI = {}
		GUI.Casting = false
		GUI.Cradle = UI.CreateFrame("Frame", "KBMAW_Cradle_Frame", KBM.Context)
		GUI.Cradle:SetLayer(5)
		--GUI.Cradle:SetHeight(math.ceil(PI.Constant.Frame.Height * PI.Settings.Anchor.hScale))
		GUI.Cradle:SetBackgroundColor(0,0,0,0.4)
		GUI.Cradle:SetVisible(false)
		GUI.Cradle.Borders = {}
		GUI.Cradle.Borders.Top = UI.CreateFrame("Texture", "KBMAW_Cradle_TOP", GUI.Cradle)
		KBM.LoadTexture(GUI.Cradle.Borders.Top, "KingMolinator", "Media/Frame_Top.png")
		GUI.Cradle.Borders.Top:SetPoint("TOPLEFT", GUI.Cradle, "TOPLEFT")
		GUI.Cradle.Borders.Top:SetPoint("RIGHT", GUI.Cradle, "RIGHT")
		GUI.Cradle.Borders.Bottom = UI.CreateFrame("Texture", "KBMAW_Cradle_BOTTOM", GUI.Cradle)
		KBM.LoadTexture(GUI.Cradle.Borders.Bottom, "KingMolinator", "Media/Frame_Bottom.png")
		GUI.Cradle.Borders.Bottom:SetPoint("BOTTOMLEFT", GUI.Cradle, "BOTTOMLEFT")
		GUI.Cradle.Borders.Bottom:SetPoint("RIGHT", GUI.Cradle, "RIGHT")
		GUI.Cradle.Borders.Left = UI.CreateFrame("Texture", "KBMAW_Cradle_LEFT", GUI.Cradle)
		KBM.LoadTexture(GUI.Cradle.Borders.Left, "KingMolinator", "Media/Frame_Left.png")
		GUI.Cradle.Borders.Left:SetPoint("TOPLEFT", GUI.Cradle.Borders.Top, "BOTTOMLEFT")
		GUI.Cradle.Borders.Left:SetPoint("BOTTOM", GUI.Cradle.Borders.Bottom, "TOP")
		GUI.Cradle.Borders.Left:SetAlpha(0.5)
		GUI.Cradle.Borders.Right = UI.CreateFrame("Texture", "KBMAW_Cradle_LEFT", GUI.Cradle)
		KBM.LoadTexture(GUI.Cradle.Borders.Right, "KingMolinator", "Media/Frame_Right.png")
		GUI.Cradle.Borders.Right:SetPoint("TOPRIGHT", GUI.Cradle.Borders.Top, "BOTTOMRIGHT")
		GUI.Cradle.Borders.Right:SetPoint("BOTTOM", GUI.Cradle.Borders.Bottom, "TOP")
		GUI.Cradle.Borders.Right:SetAlpha(0.5)
		GUI.Textures = {
			Elite = UI.CreateFrame("Texture", "Unit_Elite_Texture", GUI.Cradle),
			Normal = UI.CreateFrame("Texture", "Unit_Normal_Texture", GUI.Cradle),
		}
		KBM.LoadTexture(GUI.Textures.Elite, "KingMolinator", "Media/Level_Elite.png")
		GUI.Textures.Elite:SetPoint("CENTERLEFT", GUI.Cradle, "CENTERRIGHT", -3, -1)
		GUI.Textures.Elite:SetAlpha(0.75)
		GUI.Textures.Elite:SetVisible(false)
		KBM.LoadTexture(GUI.Textures.Normal, "KingMolinator", "Media/Level_Normal.png")
		GUI.Textures.Normal:SetPoint("CENTERLEFT", GUI.Cradle, "CENTERRIGHT", -3, -1)
		GUI.Textures.Normal:SetAlpha(0.75)
		GUI.Unit = {}
		GUI.Unit.Parent = GUI
		GUI.Unit.Power = UI.CreateFrame("Frame", "KBMAW_Power_Frame", GUI.Cradle)
		GUI.Unit.Power:SetLayer(3)
		GUI.Unit.Power:SetPoint("TOPLEFT", GUI.Cradle, "TOPLEFT", 2, 2)
		GUI.Unit.Power:SetHeight(math.floor((PI.Constant.Frame.Height * PI.Settings.Anchor.hScale) * 0.5) - 2)
		GUI.Unit.Power:SetPoint("RIGHT", GUI.Cradle, "RIGHT", -4, nil)
		GUI.Unit.PowerBar = UI.CreateFrame("Texture", "KBMAW_Power_Texture", GUI.Unit.Power)
		GUI.Unit.PowerBar:SetPoint("TOPLEFT", GUI.Unit.Power, "TOPLEFT")
		GUI.Unit.PowerBar:SetPoint("BOTTOMLEFT", GUI.Unit.Power, "BOTTOMLEFT")
		GUI.Unit.PowerBar:SetBackgroundColor(0,0,1,0.3)
		KBM.LoadTexture(GUI.Unit.PowerBar, "KingMolinator", "Media/BarTexture.png")
		GUI.Unit.Frame = UI.CreateFrame("Frame", "KBMAW_NonInteractive_UnitDisplay", GUI.Cradle)
		GUI.Unit.Frame:SetLayer(3)
		GUI.Unit.Frame:SetPoint("TOPLEFT", GUI.Unit.Power, "BOTTOMLEFT", 0, 2)
		GUI.Unit.Frame:SetPoint("RIGHT", GUI.Cradle, "RIGHT", -4, nil)
		GUI.Unit.Frame:SetHeight(math.floor((PI.Constant.Frame.Height * PI.Settings.Anchor.hScale) - 4))
		GUI.Unit.Frame:SetBackgroundColor(0,0,0,0)
		GUI.Cradle:SetHeight(GUI.Unit.Power:GetHeight() + GUI.Unit.Frame:GetHeight() + 6)
		GUI.Unit.ExtraIcon = UI.CreateFrame("Texture", "KBMAW_ExtraIcon", GUI.Unit.Frame)
		KBM.LoadTexture(GUI.Unit.ExtraIcon, "Rift", "target_portrait_LootPinata.png.dds")
		GUI.Unit.ExtraIcon:SetWidth(22)
		GUI.Unit.ExtraIcon:SetHeight(22)
		GUI.Unit.ExtraIcon:SetPoint("CENTER", GUI.Unit.Frame, "TOPLEFT")
		GUI.Unit.ExtraIcon:SetLayer(7)
		GUI.Unit.ExtraIcon:SetVisible(false)
		GUI.Unit.HP = UI.CreateFrame("Texture", "KBMAW_UnitHPBar", GUI.Unit.Frame)
		KBM.LoadTexture(GUI.Unit.HP, "KingMolinator", "Media/BarTexture.png")
		GUI.Unit.HP:SetBackgroundColor(0,1,0,0.3)
		GUI.Unit.HP:SetWidth(GUI.Unit.Frame:GetWidth())
		GUI.Unit.HP:SetPoint("TOPLEFT", GUI.Unit.Frame, "TOPLEFT")
		GUI.Unit.HP:SetPoint("BOTTOM", GUI.Unit.Frame, "BOTTOM")
		GUI.Unit.NameShadow = UI.CreateFrame("Text", "KBMAW_NameShadow", GUI.Unit.Frame)
		GUI.Unit.NameShadow:SetFontColor(0,0,0,1)
		GUI.Unit.NameShadow:SetPoint("CENTERLEFT", GUI.Unit.HP, "CENTERLEFT", 4, 1)
		GUI.Unit.NameShadow:SetLayer(2)
		GUI.Unit.Name = UI.CreateFrame("Text", "KBMAW_Name", GUI.Unit.NameShadow)
		GUI.Unit.Name:SetFontColor(1,1,1,1)
		GUI.Unit.Name:SetPoint("TOPLEFT", GUI.Unit.NameShadow, "TOPLEFT", -1, -1)
		GUI.Unit.Name:SetLayer(3)
		GUI.Unit.PercentShadow = UI.CreateFrame("Text", "KBMAW_PercentShadow", GUI.Unit.Frame)
		GUI.Unit.PercentShadow:SetFontColor(0,0,0,1)
		GUI.Unit.PercentShadow:SetLayer(2)
		GUI.Unit.PercentShadow:SetPoint("RIGHT", GUI.Unit.Frame, "RIGHT")
		GUI.Unit.PercentShadow:SetPoint("TOP", GUI.Unit.NameShadow, "TOP")
		GUI.Unit.Percent = UI.CreateFrame("Text", "KBMAW_Percent", GUI.Unit.PercentShadow)
		GUI.Unit.Percent:SetPoint("TOPLEFT", GUI.Unit.PercentShadow, "TOPLEFT", -1, -1)
		GUI.Unit.Percent:SetLayer(3)
		GUI.Unit.Percent:SetFontColor(1,1,1,1)
		GUI.Unit.Percent.Parent = GUI
		GUI.Unit.Level = {}
		GUI.Unit.Level.Texture = GUI.Textures.Normal
		GUI.Unit.Level.Text = UI.CreateFrame("Text", "Unit_Level_Text", GUI.Cradle)
		GUI.Unit.Level.Text:SetText("50")
		GUI.Unit.Level.Text:SetVisible(false)
		GUI.Unit.Level.Text:SetPoint("CENTER", GUI.Unit.Level.Texture, "CENTER", -2, 1)
		GUI.Unit.Level.Text:SetLayer(2)
		GUI.Unit.Level.Boss = UI.CreateFrame("Texture", "Unit_Level_Boss", GUI.Cradle)
		KBM.LoadTexture(GUI.Unit.Level.Boss, "KingMolinator", "Media/Boss_Icon.png")
		GUI.Unit.Level.Boss:SetPoint("CENTER", GUI.Unit.Level.Texture, "CENTER", -2, 0)
		GUI.Unit.Level.Boss:SetVisible(false)
		GUI.Unit.Level.Boss:SetLayer(2)
		GUI.Unit.Targets = {}
		GUI.Unit.Targets.Cradle = UI.CreateFrame("Frame", "Unit_Target_Cradle", KBM.Context)
		GUI.Unit.Targets.Cradle:SetWidth(math.ceil(self.GUI.Anchor:GetWidth() * 0.6))
		GUI.Unit.Targets.Cradle:SetHeight(self.GUI.Anchor:GetHeight())
		GUI.Unit.Targets.Cradle:SetPoint("LEFT", GUI.Cradle, "RIGHT")
		GUI.Unit.Targets.Cradle:SetBackgroundColor(0,0,0,0.66)
		GUI.Unit.Targets.Cradle:SetPoint("CENTERY", GUI.Cradle, "CENTERY")
		GUI.Unit.Targets.Cradle:SetLayer(6)
		GUI.Unit.Targets.Cradle.Borders = {}
		GUI.Unit.Targets.Cradle.Borders.Top = UI.CreateFrame("Texture", "KBMAW_Targets_Cradle_TOP", GUI.Unit.Targets.Cradle)
		KBM.LoadTexture(GUI.Unit.Targets.Cradle.Borders.Top, "KingMolinator", "Media/Frame_Top.png")
		GUI.Unit.Targets.Cradle.Borders.Top:SetPoint("TOPLEFT", GUI.Unit.Targets.Cradle, "TOPLEFT")
		GUI.Unit.Targets.Cradle.Borders.Top:SetPoint("RIGHT", GUI.Unit.Targets.Cradle, "RIGHT")
		GUI.Unit.Targets.Cradle.Borders.Top:SetAlpha(0.5)
		GUI.Unit.Targets.Cradle.Borders.Bottom = UI.CreateFrame("Texture", "KBMAW_Targets_Cradle_BOTTOM", GUI.Unit.Targets.Cradle)
		KBM.LoadTexture(GUI.Unit.Targets.Cradle.Borders.Bottom, "KingMolinator", "Media/Frame_Bottom.png")
		GUI.Unit.Targets.Cradle.Borders.Bottom:SetPoint("BOTTOMLEFT", GUI.Unit.Targets.Cradle, "BOTTOMLEFT")
		GUI.Unit.Targets.Cradle.Borders.Bottom:SetPoint("RIGHT", GUI.Unit.Targets.Cradle, "RIGHT")
		GUI.Unit.Targets.Cradle.Borders.Bottom:SetAlpha(0.5)
		GUI.Unit.Targets.Cradle.Borders.Left = UI.CreateFrame("Texture", "KBMAW_Targets_Cradle_LEFT", GUI.Unit.Targets.Cradle)
		KBM.LoadTexture(GUI.Unit.Targets.Cradle.Borders.Left, "KingMolinator", "Media/Frame_Left.png")
		GUI.Unit.Targets.Cradle.Borders.Left:SetPoint("TOPLEFT", GUI.Unit.Targets.Cradle.Borders.Top, "BOTTOMLEFT")
		GUI.Unit.Targets.Cradle.Borders.Left:SetPoint("BOTTOM", GUI.Unit.Targets.Cradle.Borders.Bottom, "TOP")
		GUI.Unit.Targets.Cradle.Borders.Left:SetAlpha(0.5)
		GUI.Unit.Targets.Cradle.Borders.Right = UI.CreateFrame("Texture", "KBMAW_Targets_Cradle_LEFT", GUI.Unit.Targets.Cradle)
		KBM.LoadTexture(GUI.Unit.Targets.Cradle.Borders.Right, "KingMolinator", "Media/Frame_Right.png")
		GUI.Unit.Targets.Cradle.Borders.Right:SetPoint("TOPRIGHT", GUI.Unit.Targets.Cradle.Borders.Top, "BOTTOMRIGHT")
		GUI.Unit.Targets.Cradle.Borders.Right:SetPoint("BOTTOM", GUI.Unit.Targets.Cradle.Borders.Bottom, "TOP")
		GUI.Unit.Targets.Cradle.Borders.Right:SetAlpha(0.5)
		GUI.Unit.Targets.List = {}

		AWCastCount = AWCastCount + 1
		GUI.Unit.Castbar = LibSCast:Create("AddWatch_Castbar_"..AWCastCount, GUI.Cradle, "Simple", AddWatch_CastSettings, "default")
		
		function GUI.Unit.Percent:MouseInHandler()
			if PI.Settings.Targets then
				if self.Parent.Unit.KBMUnit.TargetCount > 0 then
					self.Parent:ShowTargets()
					self.Parent.Cradle:SetBackgroundColor(0.5, 0.5, 0, 0.75)
				end
			end
		end
	
		function GUI.Unit.Percent:MouseOutHandler()
			if PI.Settings.Targets then
				self.Parent:HideTargets()
				self.Parent.Cradle:SetBackgroundColor(0, 0, 0, 0.4)
			end
		end
		
		if PI.Settings.Targets then
			GUI.Unit.Percent:EventAttach(Event.UI.Input.Mouse.Cursor.In, GUI.Unit.Percent.MouseInHandler, "Mouse In")
			GUI.Unit.Percent:EventAttach(Event.UI.Input.Mouse.Cursor.Out, GUI.Unit.Percent.MouseOutHandler, "Mouse Out")
		end
		
		function GUI:SetText(Text)
			self.IntShadow:SetText(Text)
			self.IntText:SetText(Text)
		end
		
		function GUI.PinCastbar(self)
			self.ui.cradle:ClearAll()
			self.ui.cradle:SetPoint("TOPLEFT", GUI.Unit.Frame, "BOTTOMLEFT")
			self.ui.cradle:SetPoint("RIGHT", GUI.Unit.Frame, "RIGHT")
			self.ui.cradle:SetHeight(GUI.CastHeight)
			self.ui.text:SetFontSize(GUI.Unit.Name:GetFontSize() - 1)
			self.ui.cradle:SetLayer(6)
		end
				
		function GUI:CheckYBounds()
			self.Unit.Targets.Cradle:ClearPoint("CENTERY")
			self.Unit.Targets.Cradle:SetPoint("CENTERY", self.Cradle, "CENTERY")
			local CBottom = self.Unit.Targets.Cradle:GetBottom()
			local UBottom = UIParent:GetBottom()
			local CTop = self.Unit.Targets.Cradle:GetTop()
			local UTop = UIParent:GetTop()
			if CBottom > UBottom then
				self.Unit.Targets.Cradle:SetPoint("CENTERY", self.Cradle, "CENTERY", nil, math.ceil(UBottom - CBottom))
			elseif CTop < UTop then
				self.Unit.Targets.Cradle:ClearPoint("CENTERY")
				self.Unit.Targets.Cradle:SetPoint("CENTERY", self.Cradle, "CENTERY", nil, math.ceil(UTop - CTop))
			end
		end
		
		function GUI:AddUnit(UnitID, UnitObj)
			self.Unit.Targets.List[UnitID] = {}
			local ListObj = self.Unit.Targets.List[UnitID]
			ListObj.GUI = PI:PullUnit()
			ListObj.GUI.Cradle:SetVisible(true)
			ListObj.GUI:SetText(UnitObj.Name, UnitObj.Calling)
			if self.Unit.Targets.FirstUnit then
				ListObj.UnitBefore = self.Unit.Targets.LastUnit
				ListObj.UnitBefore.UnitAfter = ListObj
				self.Unit.Targets.LastUnit.UnitAfter = ListObj
				ListObj.GUI.Cradle:SetPoint("TOP", ListObj.UnitBefore.GUI.Cradle, "BOTTOM")
				ListObj.GUI.Cradle:SetPoint("LEFT", self.Unit.Targets.Cradle, "LEFT", 2, nil)
			else
				self.Unit.Targets.FirstUnit = ListObj
				ListObj.GUI.Cradle:SetPoint("TOPLEFT", self.Unit.Targets.Cradle, "TOPLEFT", 2, 2)
			end
			self.Unit.Targets.LastUnit = ListObj
			self:CheckYBounds()
		end
		
		function GUI:RemoveUnit(UnitID)
			ListObj = self.Unit.Targets.List[UnitID]
			if self.Unit.Targets.FirstUnit == ListObj then
				self.Unit.Targets.FirstUnit = ListObj.UnitAfter
				self.Unit.Targets.FirstUnit.GUI.Cradle:SetPoint("TOPLEFT", self.Unit.Targets.Cradle, "TOPLEFT", 2, 2)
				ListObj.UnitAfter.UnitBefore = nil
			elseif self.Unit.Targets.LastUnit == ListObj then
				ListObj.UnitBefore.UnitAfter = nil
				self.Unit.Targets.LastUnit = ListObj.UnitBefore
			else
				ListObj.UnitBefore.UnitAfter = ListObj.UnitAfter
				ListObj.UnitAfter.UnitBefore = ListObj.UnitBefore
				ListObj.UnitAfter.GUI.Cradle:SetPoint("TOP", ListObj.UnitBefore.GUI.Cradle, "BOTTOM")
			end
			
			ListObj.GUI.Cradle:SetVisible(false)
			table.insert(PI.Stores.Units, ListObj.GUI)
			ListObj.GUI = nil
			self.Unit.Targets.List[UnitID] = nil
			self:CheckYBounds()
		end
		
		function GUI:ShowTargets()
			self.Unit.Targets.Cradle:SetVisible(true)
			for UnitID, UnitObj in pairs(self.Unit.KBMUnit.TargetList) do
				if not self.Unit.Targets.List[UnitID] then
					self:AddUnit(UnitID, UnitObj)
				end
			end
			for UnitID, UnitObj in pairs(self.Unit.Targets.List) do
				if not self.Unit.KBMUnit.TargetList[UnitID] then
					self:RemoveUnit(UnitID)
				end
			end
			self.Unit.Targets.Cradle:SetHeight(self.Unit.KBMUnit.TargetCount * self.Unit.Targets.LastUnit.GUI.Cradle:GetHeight() + 4)
			self.TargetsVisible = true
			self.Unit.Targets.Cradle:ClearPoint("RIGHT")
			self.Unit.Targets.Cradle:ClearPoint("LEFT")
			if PI.Settings.ShowRight then
				self.Unit.Targets.Cradle:SetPoint("LEFT", self.Cradle, "RIGHT")
				if self.Unit.Targets.Cradle:GetRight() > UIParent:GetRight() then
					self.Unit.Targets.Cradle:ClearPoint("LEFT")
					self.Unit.Targets.Cradle:SetPoint("RIGHT", self.Cradle, "LEFT")
				end
			else
				self.Unit.Targets.Cradle:SetPoint("RIGHT", self.Cradle, "LEFT")
				if self.Unit.Targets.Cradle:GetLeft() < UIParent:GetLeft() then
					self.Unit.Targets.Cradle:ClearPoint("RIGHT")
					self.Unit.Targets.Cradle:SetPoint("LEFT", self.Cradle, "RIGHT")
				end
			end
			PI.TRUCurrent = self
			self:CheckYBounds()
		end
		
		function GUI:HideTargets()
			PI.TRUCurrent = nil
			self.Unit.Targets.Cradle:SetVisible(false)
			for UnitID, ListObj in pairs(self.Unit.Targets.List) do
				ListObj.GUI.Cradle:SetVisible(false)
				table.insert(PI.Stores.Units, ListObj.GUI)
				ListObj.GUI = nil
			end
			self.Unit.Targets.List = {}
			self.Unit.Targets.LastUnit = nil
			self.Unit.Targets.FirstUnit = nil
			self.TargetsVisible = false
		end
		
		function GUI:UpdateTargets()
		end
		
		function GUI:SetCast(Visible)
			self.Casting = Visible
			if Visible then
				if PI.Settings.ShowPower then
					self.Cradle:SetHeight(self.CastHeight + self.Unit.Frame:GetHeight() + self.Unit.Power:GetHeight() + 6)
				else
					self.Cradle:SetHeight(self.CastHeight + self.Unit.Frame:GetHeight() + 4)
				end
			else
				if PI.Settings.ShowPower then
					self.Cradle:SetHeight(self.Unit.Frame:GetHeight() + self.Unit.Power:GetHeight() + 6)
				else
					self.Cradle:SetHeight(self.Unit.Frame:GetHeight() + 4)
				end
			end
		end
		
		function GUI.Unit:SetName(Text)
			if type(Text) ~= "string" or Text == "" then
				Text = "<Unknown>"
			end
			if self.Name:GetText() ~= Text then 
				self.NameShadow:SetText(Text)
				self.Name:SetText(Text)
			end
		end
		
		function GUI.Unit:SetMark(Mark)
			if self.Mark ~= Mark then
				self:ClearMark()
				if Mark then
					self.Mark = Mark
					if PI.Marks.Frame[self.Mark] then
						if PI.Marks.Frame[self.Mark] ~= self then
							PI.Marks.Frame[self.Mark]:ClearMark()
						end
					end
					PI.Marks.Frame[self.Mark] = self
					PI.Marks.Icon[self.Mark]:SetVisible(true)
					PI.Marks.Icon[self.Mark]:SetPoint("TOPLEFT", self.Frame, "TOPLEFT", 2 , 4)
					PI.Marks.Icon[self.Mark]:SetPoint("BOTTOM", self.Frame, "BOTTOM", nil, -4)
					local Scale = PI.Marks.Icon[self.Mark]:GetHeight() / PI.Marks.Defaults[self.Mark].h
					PI.Marks.Icon[self.Mark]:SetWidth(math.ceil(PI.Marks.Defaults[self.Mark].w * Scale))
					self.NameShadow:ClearPoint("CENTERLEFT")
					self.NameShadow:SetPoint("CENTERLEFT", PI.Marks.Icon[self.Mark], "CENTERRIGHT", 2, 1)
				end
			end
		end
		
		function GUI.Unit:ClearMark(Skip)
			if self.Mark then
				if PI.Marks.Frame[self.Mark] == self then
					PI.Marks.Icon[self.Mark]:SetVisible(false)
					PI.Marks.Icon[self.Mark]:ClearAll()
					PI.Marks.Frame[self.Mark] = nil
				end
			end
			self.NameShadow:ClearPoint("CENTERLEFT")
			self.NameShadow:SetPoint("CENTERLEFT", self.HP, "CENTERLEFT", 4, 1)
			self.Mark = nil
		end
		
		function GUI:SetTarget()
			if self.Unit.KBMUnit.UnitID == LibSUnit.Player.Target then
				self.Cradle.Borders.Top:SetBackgroundColor(1,0,0,1)
			else
				self.Cradle.Borders.Top:SetBackgroundColor(0,0,0,0)
			end
		end
		
		function GUI.Unit:SetPercent(Text)
			if self.KBMUnit.TargetCount > 0 and PI.Settings.Targets == true then
				local Text = Text.."%".." ["..self.KBMUnit.TargetCount.."]"
				if self.Percent:GetText() ~= Text then
					self.PercentShadow:SetText(Text)
					self.Percent:SetText(Text)
				end
			else
				local Text = Text.."%"
				if self.Percent:GetText() ~= Text then
					self.PercentShadow:SetText(Text)
					self.Percent:SetText(Text)
				end
				self.Parent:HideTargets()
			end
		end

		function GUI:Update()
			if self.Unit.KBMUnit then
				local NewWidth = math.ceil(self.Unit.KBMUnit.PercentRaw * self.Unit.Frame:GetWidth())
				if NewWidth ~= self.Unit.HP:GetWidth() then
					self.Unit.HP:SetWidth(NewWidth)
				end
				self.Unit:SetPercent(tostring(self.Unit.KBMUnit.PercentFlat))
				if PI.Settings.ShowPower then
					if self.Unit.PowerMode ~= "" then
						if self.Unit.KBMUnit.Power then
							local NewWidth = math.ceil((self.Unit.KBMUnit.Power / self.Unit.PowerMax) * self.Unit.Frame:GetWidth())
							if self.Unit.PowerBar:GetWidth() ~= NewWidth then
								self.Unit.PowerBar:SetWidth(NewWidth)
							end
						end
					end
				end
			end
		end
		
		function GUI:ApplySettings()
			if PI.Settings.Targets then
				function self.Unit.Percent.Event:MouseIn()
					if PI.Settings.Targets then
						if self.Parent.Unit.KBMUnit.TargetCount > 0 then
							self.Parent:ShowTargets()
							self.Parent.Cradle:SetBackgroundColor(0.5, 0.5, 0, 0.75)
						end
					end
				end
			
				function self.Unit.Percent.Event:MouseOut()
					if PI.Settings.Targets then
						self.Parent:HideTargets()
						self.Parent.Cradle:SetBackgroundColor(0, 0, 0, 0.4)
					end
				end
			else
				self.Unit.Percent.Event.MouseOut = nil
				self.Unit.Percent.Event.MouseIn = nil
			end
			self.Cradle:SetWidth(math.ceil(PI.Constant.Frame.Width * PI.Settings.Anchor.wScale))
			self.Cradle:SetAlpha(1)
			self.Unit.Frame:SetHeight(math.ceil(PI.Constant.Frame.Height * PI.Settings.Anchor.hScale) - 4)
			self.Unit.Name:SetFontSize(PI.Constant.Frame.TextSize * PI.Settings.Anchor.tScale)
			self.Unit.NameShadow:SetFontSize(self.Unit.Name:GetFontSize())
			self.Unit.Percent:SetFontSize(self.Unit.Name:GetFontSize())
			self.Unit.PercentShadow:SetFontSize(self.Unit.Name:GetFontSize())
			if PI.Settings.ShowPower then
				self.Unit.Power:SetHeight(math.ceil((PI.Constant.Frame.Height * 0.25) * PI.Settings.Anchor.hScale))
				self.Unit.PowerBar:SetWidth(self.Unit.Frame:GetWidth())
				self.Unit.Power:SetVisible(true)
				self.Unit.Frame:SetPoint("TOPLEFT", self.Unit.Power, "BOTTOMLEFT", 0, 1)
			else
				self.Unit.Frame:SetPoint("TOPLEFT", self.Cradle, "TOPLEFT", 2, 2)
				self.Unit.Power:SetVisible(false)
			end
			self:SetCast(self.Casting)
			if PI.Settings.ShowLevel then
				self.Unit.Level.Text:SetFontSize(self.Unit.Name:GetFontSize())
				self.Unit.Level.Boss:SetWidth(self.Unit.Level.Texture:GetHeight() - 5)
				self.Unit.Level.Boss:SetHeight(self.Unit.Level.Texture:GetHeight() - 5)
				self.Unit.Level.Texture:SetVisible(false)
				if not self.Unit.KBMUnit.Tier then
					self.Unit.Level.Texture = self.Textures.Normal
					self.Unit.Level.Text:SetPoint("CENTER", self.Textures.Normal, "CENTER", -2, 1)
				else
					self.Unit.Level.Texture = self.Textures.Elite
					self.Unit.Level.Text:SetPoint("CENTER", self.Textures.Elite, "CENTER", -2, 1)
				end
				self.Unit.Level.Texture:SetVisible(true)
				if self.Unit.KBMUnit.Level == "??" then
					self.Unit.Level.Boss:SetVisible(true)
					self.Unit.Level.Text:SetVisible(false)
				else
					self.Unit.Level.Text:SetVisible(true)
					self.Unit.Level.Boss:SetVisible(false)
					local xpLevel = self.Unit.KBMUnit.Level - LibSUnit.Player.Level
					if xpLevel > 5 then
						self.Unit.Level.Text:SetFontColor(0.9,0,0)
					elseif xpLevel > 2 and xpLevel <= 5 then
						self.Unit.Level.Text:SetFontColor(0.9,0.5,0)
					elseif xpLevel >= -2 and xpLevel <= 2 then
						self.Unit.Level.Text:SetFontColor(0.9,0.9,0)
					elseif xpLevel < -2 and xpLevel >= -5 then
						self.Unit.Level.Text:SetFontColor(0,0.9,0)
					else
						self.Unit.Level.Text:SetFontColor(0.9, 0.9, 0.9)
					end
				end
				self.Unit.Level.Texture:SetHeight(self.Unit.Frame:GetHeight() + 19)
				self.Unit.Level.Texture:SetWidth(self.Unit.Frame:GetHeight() + 13)
			else
				self.Unit.Level.Texture:SetVisible(false)
				self.Unit.Level.Text:SetVisible(false)
				self.Unit.Level.Boss:SetVisible(false)
			end
			
			self.CastHeight = math.ceil(self.Unit.Frame:GetHeight() * 0.6)
			if self.Unit.Castbar.CurrentBar then
				self.Unit.Castbar.CurrentBar:RenderSettings()
			end
		end				
		GUI.Unit.Castbar:Pin(GUI.PinCastbar)
	end
	
	GUI:HideTargets()
	return GUI
end

function PI:InitFrames()
	self.GUI = {}
	self.GUI.Anchor = UI.CreateFrame("Frame", "AddWatch_Frame_Anchor", self.Context)
	self.GUI.Anchor:SetWidth(math.ceil(PI.Constant.Frame.Width * self.Settings.Anchor.wScale))
	self.GUI.Anchor:SetHeight(math.ceil(PI.Constant.Frame.Height * self.Settings.Anchor.hScale))
	
	if not self.Settings.Anchor.x then
		self.GUI.Anchor:SetPoint("TOPLEFT", UIParent, 0.25, 0.25)
	else
		self.GUI.Anchor:SetPoint("TOPLEFT", UIParent, "TOPLEFT", self.Settings.Anchor.x, self.Settings.Anchor.y)
	end
	
	self.GUI.Anchor:SetBackgroundColor(0,0,0,0.33)
	self.GUI.Shadow = UI.CreateFrame("Text", "Anchor_Shadow", self.GUI.Anchor)
	self.GUI.Shadow:SetText(self.Lang.Pin.Anchor[KBM.Lang])
	self.GUI.Shadow:SetFontColor(0,0,0)
	self.GUI.Shadow:SetPoint("CENTER", self.GUI.Anchor, "CENTER", 1, 1)
	self.GUI.Shadow:SetLayer(1)
	self.GUI.Text = UI.CreateFrame("Text", "Anchor_Text", self.GUI.Shadow)
	self.GUI.Text:SetText(self.Lang.Pin.Anchor[KBM.Lang])
	self.GUI.Text:SetPoint("TOPLEFT", self.GUI.Shadow, "TOPLEFT", -1, -1)
	self.GUI.Text:SetLayer(2)
	self.GUI.Anchor:SetVisible(false)

	function self.GUI:Move(Type)
		if Type == "end" then
			PI.Settings.Anchor.x = self.Anchor:GetLeft()
			PI.Settings.Anchor.y = self.Anchor:GetTop()
		end
	end
	self.GUI.Drag = KBM.AttachDragFrame(self.GUI.Anchor, function (Type) self.GUI:Move(Type) end, "KBMAW_Drag")
	self.GUI.Drag.GUI = self.GUI
	
	function self.GUI:ApplySettings()
		self.Anchor:SetWidth(math.ceil(PI.Constant.Frame.Width * PI.Settings.Anchor.wScale))
		self.Anchor:SetHeight(math.ceil(PI.Constant.Frame.Height * PI.Settings.Anchor.hScale))
		self.Text:SetFontSize(PI.Constant.Frame.TextSize * PI.Settings.Anchor.tScale)
		self.Shadow:SetFontSize(self.Text:GetFontSize())
	end
	
	function self.GUI.Drag:WheelForwardHandler()	
		local Change = false
		if PI.Settings.Anchor.ScaleWidth then
			if PI.Settings.Anchor.wScale < 1.6 then
				PI.Settings.Anchor.wScale = PI.Settings.Anchor.wScale + 0.02
				if PI.Settings.Anchor.wScale > 1.6 then
					PI.Settings.Anchor.wScale = 1.6
				end
				Change = true
			end
		end
		
		if PI.Settings.Anchor.ScaleHeight then
			if PI.Settings.Anchor.hScale < 1.6 then
				PI.Settings.Anchor.hScale = PI.Settings.Anchor.hScale + 0.02
				if PI.Settings.Anchor.hScale > 1.6 then
					PI.Settings.Anchor.hScale = 1.6
				end
				Change = true
			end
		end
		
		if PI.Settings.Anchor.ScaleText then
			if PI.Settings.Anchor.tScale < 1.6 then
				PI.Settings.Anchor.tScale = PI.Settings.Anchor.tScale + 0.02
				if PI.Settings.Anchor.tScale > 1.6 then
					PI.Settings.Anchor.tScale = 1.6
				end
				Change = true
			end
		end			
		
		if Change then
			self.GUI:ApplySettings()
			for UnitID, UnitObj in pairs(PI.UnitTrack.All) do
				UnitObj.GUI:ApplySettings()
				UnitObj.GUI:Update()
			end
		end
	end

	function self.GUI.Drag:WheelBackHandler()	
		local Change = false
		if PI.Settings.Anchor.ScaleWidth then
			if PI.Settings.Anchor.wScale > 0.6 then
				PI.Settings.Anchor.wScale = PI.Settings.Anchor.wScale - 0.02
				if PI.Settings.Anchor.wScale < 0.6 then
					PI.Settings.Anchor.wScale = 0.6
				end
				Change = true
			end
		end
		
		if PI.Settings.Anchor.ScaleHeight then
			if PI.Settings.Anchor.hScale > 0.6 then
				PI.Settings.Anchor.hScale = PI.Settings.Anchor.hScale - 0.02
				if PI.Settings.Anchor.hScale < 0.6 then
					PI.Settings.Anchor.hScale = 0.6
				end
				Change = true
			end
		end
		
		if PI.Settings.Anchor.ScaleText then
			if PI.Settings.Anchor.tScale > 0.6 then
				PI.Settings.Anchor.tScale = PI.Settings.Anchor.tScale - 0.02
				if PI.Settings.Anchor.tScale < 0.6 then
					PI.Settings.Anchor.tScale = 0.6
				end
				Change = true
			end
		end
		
		if Change then
			self.GUI:ApplySettings()
			for UnitID, UnitObj in pairs(PI.UnitTrack.All) do
				UnitObj.GUI:ApplySettings()
				UnitObj.GUI:Update()
			end
		end
	end
	self.GUI.Drag:EventAttach(Event.UI.Input.Mouse.Wheel.Forward, self.GUI.Drag.WheelForwardHandler, "Mouse Wheel Forward")
	self.GUI.Drag:EventAttach(Event.UI.Input.Mouse.Wheel.Back, self.GUI.Drag.WheelBackHandler, "Mouse Wheel Back")	
	
	self.UnitTrack = {
		Live = {
			Count = 0,
		},
		Idle = {
			Count = 0,
		},
		All = {},
		Count = 0,
	}	
end

PI.Unit.Queue = {
	AddList = {},
	RemoveList = {},
}

function PI.Unit:SetPower(AWUnit, UnitObj)
	if UnitObj.PowerMode == "energy" then
		AWUnit.GUI.Unit.PowerMode = "energy"
		AWUnit.GUI.Unit.PowerMax = UnitObj.PowerMax
		AWUnit.GUI.Unit.PowerBar:SetBackgroundColor(1, 0, 1, 0.33)
	elseif UnitObj.PowerMode == "mana" then
		AWUnit.GUI.Unit.PowerMode = "mana"
		AWUnit.GUI.Unit.PowerMax = UnitObj.PowerMax
		AWUnit.GUI.Unit.PowerBar:SetBackgroundColor(0, 0.5, 1, 0.33)
	elseif UnitObj.PowerMode == "power" then
		AWUnit.GUI.Unit.PowerMode = "power"
		AWUnit.GUI.Unit.PowerMax = 100
		AWUnit.GUI.Unit.PowerBar:SetBackgroundColor(1, 1, 0, 0.33)
	else
		AWUnit.GUI.Unit.PowerMode = ""
		AWUnit.GUI.Unit.PowerBar:SetBackgroundColor(0.5, 0.5, 0.5, 0.33)
	end
end


function PI.Unit:Add(UnitObj)
	local UnitID = UnitObj.UnitID
	if PI.Settings.Enabled then
		if UnitObj.UnitID ~= LibSUnit.Player.UnitID then
			if not LibSUnit.Raid.UID[UnitID] then
				if not PI.UnitTrack.All[UnitID] then
					if UnitObj.Relation ~= "friendly" then
						if UnitObj.Dead == false then
							--print("Unit isn't Dead: Adding "..UnitID)
							if not UnitObj.Offline then
								PI.UnitTrack.Count = PI.UnitTrack.Count + 1
								PI.UnitTrack.All[UnitID] = {}
								local AWUnit = PI.UnitTrack.All[UnitID]
								AWUnit.KBMUnit = UnitObj
								AWUnit.GUI = PI:PullFrame()
								AWUnit.GUI.Cradle:SetVisible(true)
								AWUnit.GUI.Unit.KBMUnit = UnitObj
								AWUnit.GUI.Unit.Mark = nil
								AWUnit.Name = "AW_"..tostring(UnitObj.Name)
								AWUnit.GUI.Unit.Castbar:Start(UnitObj.UnitID)
								AWUnit.GUI.Unit.Level.Text:SetText(tostring(UnitObj.Level))
								self:SetPower(AWUnit, UnitObj)
								if UnitObj.GuaranteedLoot then
									AWUnit.GUI.Unit.ExtraIcon:SetVisible(true)
								else
									AWUnit.GUI.Unit.ExtraIcon:SetVisible(false)
								end
							
								if UnitObj.Name then
									AWUnit.GUI.Unit:SetName(UnitObj.Name)
								else
									AWUnit.GUI.Unit:SetName("<Unknown>")
								end
								AWUnit.GUI.Unit:SetPercent(UnitObj.Percent)
								AWUnit.GUI.Unit:SetMark(UnitObj.Mark)
								AWUnit.Available = true
								PI.GUI.Text:SetVisible(false)
								PI.GUI.Shadow:SetVisible(false)
								if PI.Settings.TargetTop then
									if UnitObj.UnitID == LibSUnit.Player.Target then
										PI.Unit:PlaceTop(AWUnit)
									else
										PI.Unit:PlaceLast(AWUnit)
									end
								else
									PI.Unit:PlaceLast(AWUnit)
								end
								AWUnit.GUI:ApplySettings()
								if UnitObj.TargetCount then
									PI.TargetCount(Event.SafesUnitLib.Unit.TargetCount, UnitObj)
								else
									AWUnit.GUI:Update()
								end
								Change = true
							end
						end
					end
				else
					if not UnitObj.Dead then
						PI.UnitTrack.Idle[UnitID] = nil
						PI.UnitTrack.All[UnitID].KBMUnit = UnitObj
						PI.UnitTrack.All[UnitID].Available = true
						PI.UnitTrack.All[UnitID].GUI.Cradle:SetAlpha(1)
					else
						self:Remove(UnitID)
					end
				end
			end
		end
	end
end

function PI.Unit:PlaceLast(AWUnit)
	if PI.UnitTrack.Count > 0 then
		if not PI.UnitTrack.LastUnit then
			AWUnit.GUI.Cradle:SetPoint("TOPLEFT", PI.GUI.Anchor, "TOPLEFT")
			PI.UnitTrack.FirstUnit = AWUnit
		else
			AWUnit.UnitBefore = PI.UnitTrack.LastUnit
			AWUnit.UnitBefore.UnitAfter = AWUnit
			if PI.Settings.Cascade then
				AWUnit.GUI.Cradle:SetPoint("TOP", AWUnit.UnitBefore.GUI.Cradle, "BOTTOM")
			else
				AWUnit.GUI.Cradle:SetPoint("BOTTOM", AWUnit.UnitBefore.GUI.Cradle, "TOP")
			end
			AWUnit.GUI.Cradle:SetPoint("LEFT", PI.GUI.Anchor, "LEFT")
		end
		PI.UnitTrack.LastUnit = AWUnit
	end
end

function PI.Unit:PlaceTop(AWUnit)
	AWUnit.GUI.Cradle:SetPoint("TOPLEFT", PI.GUI.Anchor, "TOPLEFT")
	if PI.UnitTrack.FirstUnit then
		AWUnit.UnitAfter = PI.UnitTrack.FirstUnit
		PI.UnitTrack.FirstUnit = AWUnit
		AWUnit.UnitAfter.UnitBefore = AWUnit
		AWUnit.UnitAfter.GUI.Cradle:ClearPoint("TOPLEFT")
		AWUnit.UnitAfter.GUI.Cradle:SetPoint("LEFT", PI.GUI.Anchor, "LEFT")
		if PI.Settings.Cascade then
			AWUnit.UnitAfter.GUI.Cradle:SetPoint("TOP", AWUnit.GUI.Cradle, "BOTTOM")
		else
			AWUnit.UnitAfter.GUI.Cradle:SetPoint("BOTTOM", AWUnit.GUI.Cradle, "TOP")
		end
	else
		PI.UnitTrack.FirstUnit = AWUnit
		PI.UnitTrack.LastUnit = AWUnit
	end
end

function PI.Unit:RemoveInList(AWUnit)
		PI.UnitTrack.Count = PI.UnitTrack.Count - 1
		if PI.UnitTrack.Count == 0 then
			PI.GUI.Text:SetVisible(true)
			PI.GUI.Shadow:SetVisible(true)
			PI.UnitTrack.LastUnit = nil
			PI.UnitTrack.FirstUnit = nil
		else
			if AWUnit == PI.UnitTrack.LastUnit then
				PI.UnitTrack.LastUnit = AWUnit.UnitBefore
				AWUnit.UnitBefore.UnitAfter = nil
			elseif AWUnit == PI.UnitTrack.FirstUnit then
				PI.UnitTrack.FirstUnit = AWUnit.UnitAfter
				AWUnit.UnitAfter.UnitBefore = nil
				AWUnit.UnitAfter.GUI.Cradle:ClearPoint("BOTTOM")
				AWUnit.UnitAfter.GUI.Cradle:SetPoint("TOPLEFT", PI.GUI.Anchor, "TOPLEFT")
				AWUnit.UnitAfter.GUI:ApplySettings()
			else
				AWUnit.UnitAfter.UnitBefore = AWUnit.UnitBefore
				AWUnit.UnitBefore.UnitAfter = AWUnit.UnitAfter
				if PI.Settings.Cascade then
					AWUnit.UnitAfter.GUI.Cradle:SetPoint("TOP", AWUnit.UnitBefore.GUI.Cradle, "BOTTOM")
				else
					AWUnit.UnitAfter.GUI.Cradle:SetPoint("BOTTOM", AWUnit.UnitBefore.GUI.Cradle, "TOP")
				end
				AWUnit.UnitAfter.GUI.Cradle:SetPoint("LEFT", PI.GUI.Anchor, "LEFT")
				AWUnit.UnitAfter.GUI:ApplySettings()
			end
		end
		AWUnit.GUI.Cradle:ClearPoint("TOP")
		AWUnit.GUI.Cradle:ClearPoint("BOTTOM")
		AWUnit.GUI.Cradle:ClearPoint("LEFT")
		AWUnit.GUI.Cradle:ClearPoint("TOPLEFT")
end

function PI.Unit:Remove(UnitID)
	if PI.UnitTrack.All[UnitID] then
		PI.UnitTrack.Idle[UnitID] = nil
		local AWUnit = PI.UnitTrack.All[UnitID]
		AWUnit.GUI.Unit:ClearMark()
		--print("Removing Unit: "..AWUnit.KBMUnit.Name.." ("..UnitID..")")
		PI.Unit:RemoveInList(AWUnit)
		AWUnit.GUI.Cradle:ClearPoint("TOP")
		AWUnit.GUI.Cradle:ClearPoint("BOTTOM")
		AWUnit.GUI.Cradle:ClearPoint("LEFT")
		AWUnit.GUI.Cradle:SetVisible(false)
		AWUnit.GUI:SetCast(false)
		AWUnit.GUI.Unit.Castbar:Remove()
		AWUnit.GUI:HideTargets()
		table.insert(PI.Stores.Frames, AWUnit.GUI)
		AWUnit.GUI.KBMUnit = nil
		PI.UnitTrack.All[UnitID] = nil
		Change = true
		AWUnit = nil
	end
end

function PI.UnitAvailable(handle, UnitObj)
	if PI.Settings.Enabled then
		if PI.Settings.Unknown == true or (UnitObj.Name ~= "<Unknown>" and type(UnitObj.Name) == "string") then 
			PI.Unit:Add(UnitObj)
		end
	end
end

function PI.UnitUnavailable(handle, UnitObj)
	if PI.Settings.Enabled then
		--print("** KBM MESSAGE ** Unit Unavailable: "..KBM.Unit.List.UID[UnitID].Name.." ("..UnitID..")")
		local UnitID = UnitObj.UnitID
		if (KBM.Encounter == true and PI.Settings.SmartTrack == false) or KBM.Encounter == false then
			PI.Unit:Remove(UnitID)
		else
			if not PI.UnitTrack.Idle[UnitID] then
				if PI.UnitTrack.All[UnitID] then
					PI.UnitTrack.Idle[UnitID] = PI.UnitTrack.All[UnitID]
					PI.UnitTrack.Idle[UnitID].Available = false
					PI.UnitTrack.Idle[UnitID].GUI.Cradle:SetAlpha(0.5)
					PI.UnitTrack.Idle[UnitID].GUI:SetCast(false)
				end
			end
		end
	end
end

function PI.UnitRemoved(handle, uList)
	if PI.Settings.Enabled then
		for UnitID, UnitObj in pairs(uList) do
			if PI.UnitTrack.All[UnitID] then
				PI.Unit:Remove(UnitID)
			end
		end
	end
end

function PI.UnitName(handle, Units)
	if PI.Settings.Enabled then
		for UnitID, UnitObj in pairs(Units) do
			if PI.UnitTrack.All[UnitID] then
				PI.UnitTrack.All[UnitID].GUI.Unit:SetName(UnitObj.Name)
			end
		end
	end
end

function PI.UnitUpdate(handle, UnitObj)
	if PI.Settings.Enabled then
		if PI.UnitTrack.All[UnitObj.UnitID] then
			PI.UnitTrack.All[UnitObj.UnitID].GUI:Update()
			if PI.UnitTrack.All[UnitObj.UnitID].KBMUnit then
				if UnitObj.Relation == "friendly" then
					PI.Unit:Remove(UnitObj.UnitID)
				end
			end
		end
	end
end

function PI.UnitDeath(handle, info)
	-- print("** KBM MESSAGE ** Unit Death: "..KBM.Unit.List.UID[UnitID].Name.." ("..UnitID..")")
	if PI.Settings.Enabled then
		if info.target then
			PI.Unit:Remove(info.target)
		end
	end
end

function PI.UnitRelation(handle, UnitObj)
	if PI.Settings.Enabled then
		if PI.UnitTrack.All[UnitObj.UnitID] then
			if UnitObj.Relation == "friendly" then
				PI.Unit:Remove(UnitObj.UnitID)
			elseif UnitObj.Relation ~= "friendly" then
				PI.Unit:Add(UnitObj)
			end
		end
	end
end

function PI.EncounterEnd()
	if PI.Settings.Enabled then
		for UnitID, UnitObj in pairs(PI.UnitTrack.Idle) do
			PI.Unit:Remove(UnitID)
		end
		PI.UnitTrack.Idle = {}
	end
end

function PI.MarkChange(handle, Units)
	if PI.Settings.Enabled then
		if PI.Settings.Marks then
			for UnitID, UnitObj in pairs(Units) do
				if PI.UnitTrack.All[UnitID] then
					PI.UnitTrack.All[UnitID].GUI.Unit:SetMark(UnitObj.Mark)
				end
			end
		end
	end
end

function PI.TargetChange(handle, UnitObj)
	if PI.Settings.TargetTop then
		if UnitObj == LibSUnit.Player then
			if LibSUnit.Player.Target then
				if PI.UnitTrack.All[UnitObj.Target] then
					local AWUnit = PI.UnitTrack.All[UnitObj.Target]
					if PI.UnitTrack.FirstUnit ~= AWUnit then
						PI.Unit:RemoveInList(AWUnit)
						PI.UnitTrack.Count = PI.UnitTrack.Count + 1
						PI.Unit:PlaceTop(AWUnit)
					end
				end
			end
		end
	end
end

function PI.TargetCount(handle, UnitObj)
	if PI.Settings.Enabled then
		if PI.Settings.Targets then
			local UnitID = UnitObj.UnitID
			if PI.UnitTrack.All[UnitID] then
				PI.UnitTrack.All[UnitID].GUI:Update()
				if PI.UnitTrack.All[UnitID].GUI.TargetsVisible then
					if PI.UnitTrack.All[UnitID].GUI.Unit.KBMUnit.TargetCount > 0 then
						PI.UnitTrack.All[UnitID].GUI:ShowTargets()
					else
						PI.UnitTrack.All[UnitID].GUI:HideTargets()
					end
				end
			end
		end
	end
end

function PI.CastStart(handle, BarObj, CastObj)
	if PI.Settings.Enabled then
		if PI.UnitTrack.All[CastObj.UnitID] then
			if PI.UnitTrack.All[CastObj.UnitID].GUI.Unit.Castbar == CastObj then
				PI.UnitTrack.All[CastObj.UnitID].GUI:SetCast(true)
			end
		end
	end
end

function PI.PowerChange(handle, Units)
	if PI.Settings.Enabled then
		if PI.Settings.ShowPower then
			for UnitID, UnitObj in pairs(Units) do
				if PI.UnitTrack.All[UnitID] then
					PI.UnitTrack.All[UnitID].GUI:Update()
				end
			end
		end
	end
end

function PI.PowerMaxChange(handle, Units)
	if PI.Settings.Enabled then
		if PI.Settings.ShowPower then
			for UnitID, UnitObj in pairs(Units) do
				if PI.UnitTrack.All[UnitID] then
					PI.Unit:SetPower(PI.UnitTrack.All[UnitID], UnitObj)
					PI.UnitTrack.All[UnitID].GUI:Update()
				end
			end
		end
	end
end

function PI.Zone(handle, Units)
	local UnitObj = Units[LibSUnit.Player.UnitID]
	if UnitObj then
		if UnitObj.Zone then
			local zDetails = Inspect.Zone.Detail(UnitObj.Zone)
			if zDetails.type == "warfront" then
				if not PI.InWarfront then
					PI.InWarfront = true
				end
			else
				if PI.InWarfront then
					PI.InWarfront = false
				end
			end
		end
	end
end

function PI.CastEnd(handle, BarObj, CastObj)
	if PI.Settings.Enabled then
		if PI.UnitTrack.All[CastObj.UnitID] then
			if PI.UnitTrack.All[CastObj.UnitID].GUI.Unit.Castbar == CastObj then
				PI.UnitTrack.All[CastObj.UnitID].GUI:SetCast(false)
			end
		end
	end
end

function PI:Timer(current)
	if PI.Settings.Enabled then
	end
end

function PI:MenuOpen()
	if self.Settings.Anchor.Visible then
		self.GUI.Anchor:SetVisible(true)
	end
end

function PI:MenuClose()
	self.GUI.Anchor:SetVisible(false)
end

function PI.Menu:BuildOptions()
	self.Callbacks = {}
	function self.Callbacks:Enabled(bool)
		PI.Settings.Enabled = bool
		if not bool then
			for UnitID, UnitObj in pairs(PI.UnitTrack.All) do
				PI.Unit:Remove(UnitID)
			end
		else
			for UnitID, UnitObj in pairs(LibSUnit.Lookup.UID) do
				if UnitObj.CurrentKey ~= "Idle" then
					PI.Unit:Add(UnitObj)
				end
			end
		end
	end
	
	function self.Callbacks:Cascade(bool)
		for UnitID, UnitObj in pairs(PI.UnitTrack.All) do
			if PI.Settings.Cascade then 
				if UnitObj.UnitBefore then
					UnitObj.GUI.Cradle:ClearPoint("TOP")
				end
			else
				if UnitObj.UnitBefore then
					UnitObj.GUI.Cradle:ClearPoint("BOTTOM")
				end
			end
		end
		PI.Settings.Cascade = bool
		for UnitID, UnitObj in pairs(PI.UnitTrack.All) do
			if PI.Settings.Cascade then 
				if UnitObj.UnitBefore then
					UnitObj.GUI.Cradle:SetPoint("TOP", UnitObj.UnitBefore.GUI.Cradle, "BOTTOM")
				end
			else
				if UnitObj.UnitBefore then
					UnitObj.GUI.Cradle:SetPoint("BOTTOM", UnitObj.UnitBefore.GUI.Cradle, "TOP")
				end
			end
		end
	end
	
	function self.Callbacks:TargetTop(bool)
		PI.Settings.TargetTop = bool
		PI.TargetChange(LibSUnit.Player)
	end
	
	function self.Callbacks:ShowLevel(bool)
		PI.Settings.ShowLevel = bool
		for UnitID, UnitObj in pairs(PI.UnitTrack.All) do
			UnitObj.GUI:ApplySettings()
		end
	end
	
	function self.Callbacks:ShowPower(bool)
		PI.Settings.ShowPower = bool
		for UnitID, UnitObj in pairs(PI.UnitTrack.All) do
			UnitObj.GUI:ApplySettings()
		end
	end
	
	function self.Callbacks:SmartTrack(bool)
		PI.Settings.SmartTrack = bool
	end

	function self.Callbacks:Unknown(bool)
		PI.Settings.Unknown = bool
	end
	
	function self.Callbacks:Marks(bool)
		PI.Settings.Marks = bool
		if bool then
			for UnitID, UnitObj in pairs(PI.UnitTrack.All) do
				UnitObj.GUI.Unit:SetMark(UnitObj.KBMUnit.Mark)
			end
		else
			for UnitID, UnitObj in pairs(PI.UnitTrack.All) do
				UnitObj.GUI.Unit:SetMark()
			end		
		end
	end
	
	function self.Callbacks:Targets(bool)
		PI.Settings.Targets = bool
		for UnitID, UnitObj in pairs(PI.UnitTrack.All) do
			UnitObj.GUI.Unit:SetPercent(UnitObj.KBMUnit.Percent)
			UnitObj.GUI:ApplySettings()
			if PI.Settings.Targets then
				UnitObj.GUI.Unit.Percent:EventAttach(Event.UI.Input.Mouse.Cursor.In, UnitObj.GUI.Unit.Percent.MouseInHandler, "Mouse In")
				UnitObj.GUI.Unit.Percent:EventAttach(Event.UI.Input.Mouse.Cursor.Out, UnitObj.GUI.Unit.Percent.MouseOutHandler, "Mouse Out")
			else
				UnitObj.GUI.Unit.Percent:EventDetach(Event.UI.Input.Mouse.Cursor.In, UnitObj.GUI.Unit.Percent.MouseInHandler, "Mouse In")
				UnitObj.GUI.Unit.Percent:EventDetach(Event.UI.Input.Mouse.Cursor.Out, UnitObj.GUI.Unit.Percent.MouseOutHandler, "Mouse Out")			
			end
		end
	end	
	
	function self.Callbacks:ShowRight(bool)
		PI.Settings.ShowRight = bool
		if PI.TRUCurrent then
			PI.TRUCurrent:HideTargets()
		end
	end
	
	function self.Callbacks:Visible(bool)
		PI.GUI.Anchor:SetVisible(bool)
		PI.Settings.Anchor.Visible = bool
	end
	
	function self.Callbacks:ScaleWidth(bool)
		PI.Settings.Anchor.ScaleWidth = bool
	end
	
	function self.Callbacks:ScaleHeight(bool)
		PI.Settings.Anchor.ScaleHeight = bool
	end
	
	function self.Callbacks:ScaleText(bool)
		PI.Settings.Anchor.ScaleText = bool
	end
	
	local Options = self.Settings
	
	self.Enabled = Options.UI.CreateHeader(KBM.Language.Options.Enabled[KBM.Lang], PI.Settings, "Enabled", self.Callbacks)
	self.Cascade = self.Enabled:CreateCheck(PI.Lang.Frames.Cascade[KBM.Lang], PI.Settings, "Cascade", self.Callbacks)
	self.Smart = self.Enabled:CreateCheck(PI.Lang.Frames.Smart[KBM.Lang], PI.Settings, "SmartTrack", self.Callbacks)
	self.TargetTop = self.Enabled:CreateCheck(PI.Lang.Frames.TargetTop[KBM.Lang], PI.Settings, "TargetTop", self.Callbacks)
	self.Marks = self.Enabled:CreateCheck(PI.Lang.Frames.Mark[KBM.Lang], PI.Settings, "Marks", self.Callbacks)
	self.Targets = self.Enabled:CreateCheck(PI.Lang.Frames.Target[KBM.Lang], PI.Settings, "Targets", self.Callbacks)
	self.Unknown = self.Enabled:CreateCheck(PI.Lang.Frames.Unknown[KBM.Lang], PI.Settings, "Unknown", self.Callbacks)
	self.Display = self.Enabled:CreateCheck(PI.Lang.Frames.Display[KBM.Lang], PI.Settings, "ShowRight", self.Callbacks)
	self.Level = self.Enabled:CreateCheck(PI.Lang.Frames.Level[KBM.Lang], PI.Settings, "ShowLevel", self.Callbacks)
	self.Power = self.Enabled:CreateCheck(PI.Lang.Frames.Power[KBM.Lang], PI.Settings, "ShowPower", self.Callbacks)
	self.Visible = self.Enabled:CreateHeader(PI.Lang.Pin.Visible[KBM.Lang], PI.Settings.Anchor, "Visible", self.Callbacks)
	self.Width = self.Visible:CreateCheck(KBM.Language.Options.UnlockWidth[KBM.Lang], PI.Settings.Anchor, "ScaleWidth", self.Callbacks)
	self.Height = self.Visible:CreateCheck(KBM.Language.Options.UnlockHeight[KBM.Lang], PI.Settings.Anchor, "ScaleHeight", self.Callbacks)
	self.Text = self.Visible:CreateCheck(KBM.Language.Options.UnlockText[KBM.Lang], PI.Settings.Anchor, "ScaleText", self.Callbacks)
end

function PI.LoadCache(handle, AddonID)
	if AddonID == AddonIni.id then
		PI:InitFrames()
		for Cached = 1, PI.MaxCache do
			local TempGUI = PI:PullFrame()
			TempGUI.Cradle:SetVisible(false)
			table.insert(PI.TempGUI, TempGUI)
			local TempUGUI = PI:PullUnit()
			TempUGUI.Cradle:SetVisible(false)
			table.insert(PI.TempUGUI, TempUGUI)
		end
		for n, GUIObj in ipairs(PI.TempGUI) do
			table.insert(PI.Stores.Frames, GUIObj)
		end
		for n, GUIObj in ipairs(PI.TempUGUI) do
			table.insert(PI.Stores.Units, GUIObj)
		end
		PI.TempGUI = {}
		PI.TempUGUI = {}
		PI.Marks.Defaults = {}
		for i, File in pairs(KBM.Marks.File) do
			PI.Marks.Icon[i] = UI.CreateFrame("Texture", File, KBM.Context)
			PI.Marks.Icon[i]:SetTexture(KBM.Marks.Location[i] or "Rift", File)
			PI.Marks.Icon[i]:SetVisible(false)
			PI.Marks.Icon[i]:SetLayer(MARK_LAYER)
			PI.Marks.Defaults[i] = {
				w = PI.Marks.Icon[i]:GetWidth(),
				h = PI.Marks.Icon[i]:GetHeight(),
			}
		end		
	end
end

function PI:Start()
	if Run then
		self.Menu.Header = 	KBM.Menu.Page:CreateHeader(self.Name, "KBM_ADDWATCH", "Main", "Plug")
		self.Menu.Settings = self.Menu.Header:CreateItem(KBM.Language.Options.Settings[KBM.Lang], "KBM_ADDWATCH_SETTINGS")
		self.Menu:BuildOptions()
				
		-- LibSUnit Events
		Command.Event.Attach(Event.SafesUnitLib.Unit.Mark, PI.MarkChange, "Mark_Change")
		Command.Event.Attach(Event.SafesUnitLib.Unit.New.Full, PI.UnitAvailable, "Unit_Available")
		Command.Event.Attach(Event.SafesUnitLib.Unit.Full, PI.UnitAvailable, "Unit_Available")
		Command.Event.Attach(Event.SafesUnitLib.Unit.Idle, PI.UnitUnavailable, "Unit_Unavailable")
		Command.Event.Attach(Event.SafesUnitLib.Unit.Removed, PI.UnitRemoved, "Unit_Removed")
		Command.Event.Attach(Event.SafesUnitLib.Combat.Death, PI.UnitDeath, "Unit_Dead")
		Command.Event.Attach(Event.SafesUnitLib.Unit.Detail.Name, PI.UnitName, "Unit_Name")
		Command.Event.Attach(Event.SafesUnitLib.Unit.Detail.Percent, PI.UnitUpdate, "Unit_Update")
		Command.Event.Attach(Event.SafesUnitLib.Unit.Detail.Relation, PI.UnitRelation, "Unit_Relation")
		Command.Event.Attach(Event.SafesUnitLib.Unit.Target, PI.TargetChange, "Target_Change")
		Command.Event.Attach(Event.SafesUnitLib.Unit.TargetCount, PI.TargetCount, "Target_Count")
		Command.Event.Attach(Event.SafesUnitLib.Unit.Detail.Power, PI.PowerChange, "Power_Change")
		Command.Event.Attach(Event.SafesUnitLib.Unit.Detail.PowerMax, PI.PowerMaxChange, "Power_Max_Change")
		Command.Event.Attach(Event.SafesUnitLib.Unit.Detail.Zone, PI.Zone, "Zone Change")

		-- KBM Events
		Command.Event.Attach(Event.KingMolinator.Encounter.End, PI.EncounterEnd, "Encounter_End")
		Command.Event.Attach(Event.SafesCastbarLib.Castbar.Show, PI.CastStart, "Cast_Start")
		Command.Event.Attach(Event.SafesCastbarLib.Castbar.Hide, PI.CastEnd, "Cast_End")
		
		PI.Warfront = false
		PI.Zone(handle, {[LibSUnit.Player.UnitID] = LibSUnit.Player})
	end
end

if Run then
	Command.Event.Attach(Event.Addon.Load.End, PI.LoadCache, "Pre-fetch Cache")
end